
function [exitTime status sl_counter tp_counter] = instantPipExit(t,BuyorSell,sl,tp, exit_on_close)
    LIMIT = tp/10000; 
    STOP = sl/10000;  
    global spread  % 2 pip (1 to enter, 1 to exit)
    global data
    
    tp_counter = 0;
    sl_counter = 0;    
    exitTime = NaN;
    status = NaN;    
    exitSLTP = NaN;
    
    cond = zeros(1,3);    
    
    length = size(data,1);
    
    price = data(:,3); %to calculate SLTP on open
    high = data(:,4);
    low = data(:,5);
    close = data(:,6);
   
    
    if (t > length - 1)   % last bar
        
         exitTime = t;
         status = 0;
         sl_counter = 0;
         tp_counter  = 0;
        
        return;
    end
    
   if strcmp(BuyorSell,'SELL')
         sign = -1;
    else
         sign = 1;
   end
    % t is last closed bar time
    % (t+1) is used as open of next bar - this is trade execution time.    
    % t can not be used as futre leak will occur, indicators are
    % calculated on last closed bar - it also matches MT4 execution
          
    stop = price(t+1) - sign*(STOP - 2*spread);      % if SELL then sign is minus
    limit = price(t+1) + sign*(LIMIT + 2*spread);     % stop loss is higher than buy price
            
    for i = t+1:length
      if strcmp(BuyorSell,'SELL')  % SELL order
        
        if(high(i)>stop )          % worst case scenario SL hit first
                    status = 0;
                    exitSLTP=1; % SL for short sell
                    exitTime = i;                    
        elseif (low(i)<limit )
                    status = 1;
                    exitSLTP=1; % TP for short sell
                    exitTime = i;
        end         
               
        
  
      else % BUY order
          
        if (low(i)<stop)         % worst case scenario SL hit first
                    status = 0;
                    exitSLTP=1; % SL for long buy 
                    exitTime = i;                  
        elseif(high(i)>limit) 
                    status = 1;
                    exitSLTP=1; % TP for long buy
                    exitTime = i;                    
        end  
        
        
            
      end
        
        if exitSLTP==1
                break;
        end

%        if strcmp(BuyorSell,'SELL')
%            cond(1) = pSAR(i) < close(i); % parabolic SAR below
%            cond(2) = (MACDSign(i)) > 0 && (MAhist(i) > 0); %TODO: cross over above
%        else
%            cond(1) = pSAR(i) > close(i); % parabolic SAR below
%            cond(2) = (MACDSign(i)) < 0 && (MAhist(i) < 0); %TODO: cross over below
%        end


%        if sum(cond) >= 1
%            exitTime = i;
%            break;        
%        end
    end
    

    
    if exitTime > 0%scf
        
      if exit_on_close == 1
        
        if strcmp(BuyorSell,'SELL')
            if (close(exitTime) < (close(t)- 2*spread))% Short trades only profitable on close
                
                if status == 0                
                sl_counter = 1;
                end
                
                status = 1; % success trade
            else  
                
                if status == 1                                
                tp_counter = 1;
                end
                
                status = 0;
            end 
            
        else
              
            if (close(exitTime) > (close(t)+ 2*spread))% Long trades only profitable on close
                
                if status == 0                                
                sl_counter = 1;
                end
                
                status = 1; % success trade
            else  
                
                if status == 1
                tp_counter = 1;
                end
                
                status = 0;
            end
              
        end
      
      end   
        
    else
        
       status = 2;            % not closed trades
       exitTime = length;     % exit time last bar of OOS period - to match with MT4 tester
        
    end

    
    