% trend - Sub indicator
% Author: Linh Vu

% Input: 
% - sequence is a mx1 matrix (array)
% - t: index in sequence to test direction
% - direction: 'DOWN' or 'UP'
%
% Output:
% - 0: not a trend
% - 1: trend confirm
function x = trend(sequence, t, direction, duration)
    % Algorithm: at time t, a sequence is up trend if it's been up for the 
    % last N period.
    % This is simplification, also here we choose N = 3
    
    
    if strcmp(direction , 'UP')
        dir = 1;
    else
        dir = -1;
    end
    
    if (t < duration+1) 
        x = 0;
    else
        
        if (duration == 2)
        x = ((sequence(t) - sequence(t-1))*dir > 0) && ((sequence(t-1) - sequence(t-2))*dir > 0); 
        end
        
        if (duration == 3)
        x = ((sequence(t) - sequence(t-1))*dir > 0) && ((sequence(t-1) - sequence(t-2))*dir > 0) && ((sequence(t-2) - sequence(t-3))*dir > 0); 
        end
        
        if (duration == 4)
        x = ((sequence(t) - sequence(t-1))*dir > 0) && ((sequence(t-1) - sequence(t-2))*dir > 0) && ((sequence(t-2) - sequence(t-3))*dir > 0) && ((sequence(t-3) - sequence(t-4))*dir > 0); 
        end
        
        if (duration == 5)
        x = ((sequence(t) - sequence(t-1))*dir > 0) && ((sequence(t-1) - sequence(t-2))*dir > 0) && ((sequence(t-2) - sequence(t-3))*dir > 0) && ((sequence(t-3) - sequence(t-4))*dir > 0) && ((sequence(t-4) - sequence(t-5))*dir > 0); 
        end
        
        if (duration == 6)
        x = ((sequence(t) - sequence(t-1))*dir > 0) && ((sequence(t-1) - sequence(t-2))*dir > 0) && ((sequence(t-2) - sequence(t-3))*dir > 0) && ((sequence(t-3) - sequence(t-4))*dir > 0) && ((sequence(t-4) - sequence(t-5))*dir > 0) && ((sequence(t-5) - sequence(t-6))*dir > 0); 
        end
        
            
    end